ICU 55.1 55.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Namespaces | Macros | Typedefs | Enumerations | Functions
usearch.h File Reference

C API: StringSearch. More...

`#include "unicode/utypes.h"`
`#include "unicode/localpointer.h"`
`#include "unicode/ucol.h"`
`#include "unicode/ucoleitr.h"`
`#include "unicode/ubrk.h"`

Go to the source code of this file.

## Namespaces
namespace | icu
| File coll.h.

## Macros
#define | USEARCH_DONE -1
| DONE is returned by previous() and next() after all valid matches have been returned, and by first() and last() if there are no matches at all.

## Typedefs
typedef struct UStringSearch | UStringSearch
| Data structure for searching.

## Enumerations
enum | USearchAttribute { USEARCH_OVERLAP = 0, USEARCH_CANONICAL_MATCH = 1, USEARCH_ELEMENT_COMPARISON = 2, USEARCH_ATTRIBUTE_COUNT = 3 }
enum | USearchAttributeValue { USEARCH_DEFAULT = -1, USEARCH_OFF, USEARCH_ON, USEARCH_STANDARD_ELEMENT_COMPARISON, USEARCH_PATTERN_BASE_WEIGHT_IS_WILDCARD, USEARCH_ANY_BASE_WEIGHT_IS_WILDCARD, USEARCH_ATTRIBUTE_VALUE_COUNT }

## Functions
UStringSearch * | usearch_open (const UChar *pattern, int32_t patternlength, const UChar *text, int32_t textlength, const char *locale, UBreakIterator *breakiter, UErrorCode *status)
| Creating a search iterator data struct using the argument locale language rule set.
UStringSearch * | usearch_openFromCollator (const UChar *pattern, int32_t patternlength, const UChar *text, int32_t textlength, const UCollator *collator, UBreakIterator *breakiter, UErrorCode *status)
| Creating a search iterator data struct using the argument collator language rule set.
void | usearch_close (UStringSearch *searchiter)
| Destroying and cleaning up the search iterator data struct.
void | usearch_setOffset (UStringSearch *strsrch, int32_t position, UErrorCode *status)
| Sets the current position in the text string which the next search will start from.
int32_t | usearch_getOffset (const UStringSearch *strsrch)
| Return the current index in the string text being searched.
void | usearch_setAttribute (UStringSearch *strsrch, USearchAttribute attribute, USearchAttributeValue value, UErrorCode *status)
| Sets the text searching attributes located in the enum USearchAttribute with values from the enum USearchAttributeValue.
USearchAttributeValue | usearch_getAttribute (const UStringSearch *strsrch, USearchAttribute attribute)
| Gets the text searching attributes.
int32_t | usearch_getMatchedStart (const UStringSearch *strsrch)
| Returns the index to the match in the text string that was searched.
int32_t | usearch_getMatchedLength (const UStringSearch *strsrch)
| Returns the length of text in the string which matches the search pattern.
int32_t | usearch_getMatchedText (const UStringSearch *strsrch, UChar *result, int32_t resultCapacity, UErrorCode *status)
| Returns the text that was matched by the most recent call to `usearch_first`, `usearch_next`, `usearch_previous`, or `usearch_last`.
void | usearch_setBreakIterator (UStringSearch *strsrch, UBreakIterator *breakiter, UErrorCode *status)
| Set the BreakIterator that will be used to restrict the points at which matches are detected.
const UBreakIterator * | usearch_getBreakIterator (const UStringSearch *strsrch)
| Returns the BreakIterator that is used to restrict the points at which matches are detected.
void | usearch_setText (UStringSearch *strsrch, const UChar *text, int32_t textlength, UErrorCode *status)
| Set the string text to be searched.
const UChar * | usearch_getText (const UStringSearch *strsrch, int32_t *length)
| Return the string text to be searched.
UCollator * | usearch_getCollator (const UStringSearch *strsrch)
| Gets the collator used for the language rules.
void | usearch_setCollator (UStringSearch *strsrch, const UCollator *collator, UErrorCode *status)
| Sets the collator used for the language rules.
void | usearch_setPattern (UStringSearch *strsrch, const UChar *pattern, int32_t patternlength, UErrorCode *status)
| Sets the pattern used for matching.
const UChar * | usearch_getPattern (const UStringSearch *strsrch, int32_t *length)
| Gets the search pattern.
int32_t | usearch_first (UStringSearch *strsrch, UErrorCode *status)
| Returns the first index at which the string text matches the search pattern.
int32_t | usearch_following (UStringSearch *strsrch, int32_t position, UErrorCode *status)
| Returns the first index equal or greater than `position` at which the string text matches the search pattern.
int32_t | usearch_last (UStringSearch *strsrch, UErrorCode *status)
| Returns the last index in the target text at which it matches the search pattern.
int32_t | usearch_preceding (UStringSearch *strsrch, int32_t position, UErrorCode *status)
| Returns the first index less than `position` at which the string text matches the search pattern.
int32_t | usearch_next (UStringSearch *strsrch, UErrorCode *status)
| Returns the index of the next point at which the string text matches the search pattern, starting from the current position.
int32_t | usearch_previous (UStringSearch *strsrch, UErrorCode *status)
| Returns the index of the previous point at which the string text matches the search pattern, starting at the current position.
void | usearch_reset (UStringSearch *strsrch)
| Reset the iteration.
UBool | usearch_search (UStringSearch *strsrch, int32_t startIdx, int32_t *matchStart, int32_t *matchLimit, UErrorCode *status)
| Simple forward search for the pattern, starting at a specified index, and using using a default set search options.
UBool | usearch_searchBackwards (UStringSearch *strsrch, int32_t startIdx, int32_t *matchStart, int32_t *matchLimit, UErrorCode *status)
| Simple backwards search for the pattern, starting at a specified index, and using using a default set search options.

## Detailed Description

C API: StringSearch.

C Apis for an engine that provides language-sensitive text searching based on the comparison rules defined in a `UCollator` data struct, see `ucol.h`. This ensures that language eccentricity can be handled, e.g. for the German collator, characters ß and SS will be matched if case is chosen to be ignored. See the "ICU Collation Design Document" for more information.

The implementation may use a linear search or a modified form of the Boyer-Moore search; for more information on the latter see "Efficient Text Searching in Java", published in Java Report in February, 1999.

There are 2 match options for selection:
Let S' be the sub-string of a text string S between the offsets start and end <start, end>.
A pattern string P matches a text string S at the offsets <start, end> if

    option 1. Some canonical equivalent of P matches some canonical equivalent
              of S'
    option 2. P matches S' and if P starts or ends with a combining mark,
              there exists no non-ignorable combining mark before or after S'
              in S respectively.

Option 2. will be the default.

This search has APIs similar to that of other text iteration mechanisms such as the break iterators in `ubrk.h`. Using these APIs, it is easy to scan through text looking for all occurances of a given pattern. This search iterator allows changing of direction by calling a `reset` followed by a `next` or `previous`. Though a direction change can occur without calling `reset` first, this operation comes with some speed penalty. Generally, match results in the forward direction will match the result matches in the backwards direction in the reverse order

`usearch.h` provides APIs to specify the starting position within the text string to be searched, e.g. `usearch_setOffset`, `usearch_preceding` and `usearch_following`. Since the starting position will be set as it is specified, please take note that there are some dangerous positions which the search may render incorrect results:

- The midst of a substring that requires normalization.
- If the following match is to be found, the position should not be the second character which requires to be swapped with the preceding character. Vice versa, if the preceding match is to be found, position to search from should not be the first character which requires to be swapped with the next character. E.g certain Thai and Lao characters require swapping.
- If a following pattern match is to be found, any position within a contracting sequence except the first will fail. Vice versa if a preceding pattern match is to be found, a invalid starting point would be any character within a contracting sequence except the last.

A breakiterator can be used if only matches at logical breaks are desired. Using a breakiterator will only give you results that exactly matches the boundaries given by the breakiterator. For instance the pattern "e" will not be found in the string "\u00e9" if a character break iterator is used.

Options are provided to handle overlapping matches. E.g. In English, overlapping matches produces the result 0 and 2 for the pattern "abab" in the text "ababab", where else mutually exclusive matches only produce the result of 0.

Options are also provided to implement "asymmetric search" as described in UTS #10 Unicode Collation Algorithm, specifically the USearchAttribute USEARCH_ELEMENT_COMPARISON and its values.

Though collator attributes will be taken into consideration while performing matches, there are no APIs here for setting and getting the attributes. These attributes can be set by getting the collator from `usearch_getCollator` and using the APIs in `ucol.h`. Lastly to update String Search to the new collator attributes, usearch_reset() has to be called.

Restriction:
Currently there are no composite characters that consists of a character with combining class > 0 before a character with combining class == 0. However, if such a character exists in the future, the search mechanism does not guarantee the results for option 1.

Example of use:

    char *tgtstr = "The quick brown fox jumped over the lazy fox";
    char *patstr = "fox";
    UChar target[64];
    UChar pattern[16];
    UErrorCode status = U_ZERO_ERROR;
    u_uastrcpy(target, tgtstr);
    u_uastrcpy(pattern, patstr);

    UStringSearch *search = usearch_open(pattern, -1, target, -1, "en_US",
                                     NULL, &status);
    if (U_SUCCESS(status)) {
        for (int pos = usearch_first(search, &status);
             pos != USEARCH_DONE;
             pos = usearch_next(search, &status))
        {
            printf("Found match at %d pos, length is %d\n", pos,
                                           usearch_getMatchLength(search));
        }
    }

    usearch_close(search);

Stable:
  ICU 2.4

Definition in file usearch.h.

## Macro Definition Documentation

#define USEARCH_DONE -1

DONE is returned by previous() and next() after all valid matches have been returned, and by first() and last() if there are no matches at all.

Stable:
  ICU 2.4

Definition at line 145 of file usearch.h.

## Typedef Documentation

typedef struct UStringSearch UStringSearch

Data structure for searching.

Stable:
  ICU 2.4

Definition at line 156 of file usearch.h.

## Enumeration Type Documentation

enum USearchAttribute

Stable:
  ICU 2.4

Enumerator:

  USEARCH_OVERLAP | Option for overlapping matches. Stable: ICU 2.4
  USEARCH_CANONICAL_MATCH | Option for canonical matches; option 1 in header documentation. The default value will be USEARCH_OFF. Note: Setting this option to USEARCH_ON currently has no effect on search behavior, and this option is deprecated. Instead, to control canonical match behavior, you must set UCOL_NORMALIZATION_MODE appropriately (to UCOL_OFF or UCOL_ON) in the UCollator used by the UStringSearch object. See Also usearch_openFromCollator usearch_getCollator usearch_setCollator ucol_getAttribute Deprecated: ICU 53
  USEARCH_ELEMENT_COMPARISON | Option to control how collation elements are compared. The default value will be USEARCH_STANDARD_ELEMENT_COMPARISON. Stable: ICU 4.4
  USEARCH_ATTRIBUTE_COUNT | Count of attribute types. Stable: ICU 2.4

Definition at line 161 of file usearch.h.

enum USearchAttributeValue

Stable:
  ICU 2.4

Enumerator:

  USEARCH_DEFAULT | Default value for any USearchAttribute. Stable: ICU 2.4
  USEARCH_OFF | Value for USEARCH_OVERLAP and USEARCH_CANONICAL_MATCH. Stable: ICU 2.4
  USEARCH_ON | Value for USEARCH_OVERLAP and USEARCH_CANONICAL_MATCH. Stable: ICU 2.4
  USEARCH_STANDARD_ELEMENT_COMPARISON | Value (default) for USEARCH_ELEMENT_COMPARISON; standard collation element comparison at the specified collator strength. Stable: ICU 4.4
  USEARCH_PATTERN_BASE_WEIGHT_IS_WILDCARD | Value for USEARCH_ELEMENT_COMPARISON; collation element comparison is modified to effectively provide behavior between the specified strength and strength - 1. Collation elements in the pattern that have the base weight for the specified strength are treated as "wildcards" that match an element with any other weight at that collation level in the searched text. For example, with a secondary-strength English collator, a plain 'e' in the pattern will match a plain e or an e with any diacritic in the searched text, but an e with diacritic in the pattern will only match an e with the same diacritic in the searched text. This supports "asymmetric search" as described in UTS #10 Unicode Collation Algorithm. Stable: ICU 4.4
  USEARCH_ANY_BASE_WEIGHT_IS_WILDCARD | Value for USEARCH_ELEMENT_COMPARISON. collation element comparison is modified to effectively provide behavior between the specified strength and strength - 1. Collation elements in either the pattern or the searched text that have the base weight for the specified strength are treated as "wildcards" that match an element with any other weight at that collation level. For example, with a secondary-strength English collator, a plain 'e' in the pattern will match a plain e or an e with any diacritic in the searched text, but an e with diacritic in the pattern will only match an e with the same diacritic or a plain e in the searched text. This option is similar to "asymmetric search" as described in UTS #10 Unicode Collation Algorithm</a, but also allows unmarked characters in the searched text to match marked or unmarked versions of that character in the pattern. stable 5374.
  USEARCH_ATTRIBUTE_VALUE_COUNT | Count of attribute values. Stable: ICU 2.4

Definition at line 201 of file usearch.h.

## Function Documentation

void usearch_close | ( | UStringSearch * | searchiter | ) |

Destroying and cleaning up the search iterator data struct.

If a collator is created in `usearch_open`, it will be destroyed here.

Parameters

  searchiter | data struct to clean up

Stable:
  ICU 2.4

int32_t usearch_first | ( | UStringSearch * | strsrch,
|  | UErrorCode * | status
| ) |  |

Returns the first index at which the string text matches the search pattern.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`.

Parameters

  strsrch | search iterator data struct
  status | for errors if it occurs

Returns
  The character index of the first match, or `USEARCH_DONE` if there are no matches.

See Also
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_following | ( | UStringSearch * | strsrch,
|  | int32_t | position,
|  | UErrorCode * | status
| ) |  |

Returns the first index equal or greater than `position` at which the string text matches the search pattern.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`

Search positions that may render incorrect results are highlighted in the header comments. If position is less than or greater than the text range for searching, an U_INDEX_OUTOFBOUNDS_ERROR will be returned

Parameters

  strsrch | search iterator data struct
  position | to start the search at
  status | for errors if it occurs

Returns
  The character index of the first match following `pos`, or `USEARCH_DONE` if there are no matches.

See Also
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

USearchAttributeValue usearch_getAttribute | ( | const UStringSearch * | strsrch,
|  | USearchAttribute | attribute
| ) |  |

Gets the text searching attributes.

Parameters

  strsrch | search iterator data struct
  attribute | text attribute to be retrieve

Returns
  text attribute value

See Also
  usearch_setAttribute

Stable:
  ICU 2.4

const UBreakIterator* usearch_getBreakIterator | ( | const UStringSearch * | strsrch | ) |

Returns the BreakIterator that is used to restrict the points at which matches are detected.

This will be the same object that was passed to the constructor or to `usearch_setBreakIterator`. Note that `NULL` is a legal value; it means that break detection should not be attempted.

Parameters

  strsrch | search iterator data struct

Returns
  break iterator used

See Also
  usearch_setBreakIterator

Stable:
  ICU 2.4

UCollator* usearch_getCollator | ( | const UStringSearch * | strsrch | ) |

Gets the collator used for the language rules.

Deleting the returned `UCollator` before calling `usearch_close` would cause the string search to fail. `usearch_close` will delete the collator if this search owns it.

Parameters

  strsrch | search iterator data struct

Returns
  collator

Stable:
  ICU 2.4

int32_t usearch_getMatchedLength | ( | const UStringSearch * | strsrch | ) |

Returns the length of text in the string which matches the search pattern.

This call returns a valid result only after a successful call to `usearch_first`, `usearch_next`, `usearch_previous`, or `usearch_last`. Just after construction, or after a searching method returns `USEARCH_DONE`, this method will return 0.

Parameters

  strsrch | search iterator data struct

Returns
  The length of the match in the string text, or 0 if there is no match currently.

See Also
  usearch_first
  usearch_next
  usearch_previous
  usearch_last
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_getMatchedStart | ( | const UStringSearch * | strsrch | ) |

Returns the index to the match in the text string that was searched.

This call returns a valid result only after a successful call to `usearch_first`, `usearch_next`, `usearch_previous`, or `usearch_last`. Just after construction, or after a searching method returns `USEARCH_DONE`, this method will return `USEARCH_DONE`.

Use `usearch_getMatchedLength` to get the matched string length.

Parameters

  strsrch | search iterator data struct

Returns
  index to a substring within the text string that is being searched.

See Also
  usearch_first
  usearch_next
  usearch_previous
  usearch_last
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_getMatchedText | ( | const UStringSearch * | strsrch,
|  | UChar * | result,
|  | int32_t | resultCapacity,
|  | UErrorCode * | status
| ) |  |

Returns the text that was matched by the most recent call to `usearch_first`, `usearch_next`, `usearch_previous`, or `usearch_last`.

If the iterator is not pointing at a valid match (e.g. just after construction or after `USEARCH_DONE` has been returned, returns an empty string. If result is not large enough to store the matched text, result will be filled with the partial text and an U_BUFFER_OVERFLOW_ERROR will be returned in status. result will be null-terminated whenever possible. If the buffer fits the matched text exactly, a null-termination is not possible, then a U_STRING_NOT_TERMINATED_ERROR set in status. Pre-flighting can be either done with length = 0 or the API `usearch_getMatchLength`.

Parameters

  strsrch | search iterator data struct
  result | UChar buffer to store the matched string
  resultCapacity | length of the result buffer
  status | error returned if result is not large enough

Returns
  exact length of the matched text, not counting the null-termination

See Also
  usearch_first
  usearch_next
  usearch_previous
  usearch_last
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_getOffset | ( | const UStringSearch * | strsrch | ) |

Return the current index in the string text being searched.

If the iteration has gone past the end of the text (or past the beginning for a backwards search), `USEARCH_DONE` is returned.

Parameters

  strsrch | search iterator data struct

See Also
  USEARCH_DONE

Stable:
  ICU 2.4

const UChar* usearch_getPattern | ( | const UStringSearch * | strsrch,
|  | int32_t * | length
| ) |  |

Gets the search pattern.

Parameters

  strsrch | search iterator data struct
  length | return length of the pattern, -1 indicates that the pattern is null-terminated

Returns
  pattern string

Stable:
  ICU 2.4

const UChar* usearch_getText | ( | const UStringSearch * | strsrch,
|  | int32_t * | length
| ) |  |

Return the string text to be searched.

Parameters

  strsrch | search iterator data struct
  length | returned string text length

Returns
  string text

See Also
  usearch_setText

Stable:
  ICU 2.4

int32_t usearch_last | ( | UStringSearch * | strsrch,
|  | UErrorCode * | status
| ) |  |

Returns the last index in the target text at which it matches the search pattern.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`.

Parameters

  strsrch | search iterator data struct
  status | for errors if it occurs

Returns
  The index of the first match, or `USEARCH_DONE` if there are no matches.

See Also
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_next | ( | UStringSearch * | strsrch,
|  | UErrorCode * | status
| ) |  |

Returns the index of the next point at which the string text matches the search pattern, starting from the current position.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`

Parameters

  strsrch | search iterator data struct
  status | for errors if it occurs

Returns
  The index of the next match after the current position, or `USEARCH_DONE` if there are no more matches.

See Also
  usearch_first
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

UStringSearch* usearch_open | ( | const UChar * | pattern,
|  | int32_t | patternlength,
|  | const UChar * | text,
|  | int32_t | textlength,
|  | const char * | locale,
|  | UBreakIterator * | breakiter,
|  | UErrorCode * | status
| ) |  |

Creating a search iterator data struct using the argument locale language rule set.

A collator will be created in the process, which will be owned by this search and will be deleted in `usearch_close`.

Parameters

  pattern | for matching
  patternlength | length of the pattern, -1 for null-termination
  text | text string
  textlength | length of the text string, -1 for null-termination
  locale | name of locale for the rules to be used
  breakiter | A BreakIterator that will be used to restrict the points at which matches are detected. If a match is found, but the match's start or end index is not a boundary as determined by the `BreakIterator`, the match will be rejected and another will be searched for. If this parameter is `NULL`, no break detection is attempted.
  status | for errors if it occurs. If pattern or text is NULL, or if patternlength or textlength is 0 then an U_ILLEGAL_ARGUMENT_ERROR is returned.

Returns
  search iterator data structure, or NULL if there is an error.

Stable:
  ICU 2.4

UStringSearch* usearch_openFromCollator | ( | const UChar * | pattern,
|  | int32_t | patternlength,
|  | const UChar * | text,
|  | int32_t | textlength,
|  | const UCollator * | collator,
|  | UBreakIterator * | breakiter,
|  | UErrorCode * | status
| ) |  |

Creating a search iterator data struct using the argument collator language rule set.

Note, user retains the ownership of this collator, thus the responsibility of deletion lies with the user. NOTE: string search cannot be instantiated from a collator that has collate digits as numbers (CODAN) turned on.

Parameters

  pattern | for matching
  patternlength | length of the pattern, -1 for null-termination
  text | text string
  textlength | length of the text string, -1 for null-termination
  collator | used for the language rules
  breakiter | A BreakIterator that will be used to restrict the points at which matches are detected. If a match is found, but the match's start or end index is not a boundary as determined by the `BreakIterator`, the match will be rejected and another will be searched for. If this parameter is `NULL`, no break detection is attempted.
  status | for errors if it occurs. If collator, pattern or text is NULL, or if patternlength or textlength is 0 then an U_ILLEGAL_ARGUMENT_ERROR is returned.

Returns
  search iterator data structure, or NULL if there is an error.

Stable:
  ICU 2.4

int32_t usearch_preceding | ( | UStringSearch * | strsrch,
|  | int32_t | position,
|  | UErrorCode * | status
| ) |  |

Returns the first index less than `position` at which the string text matches the search pattern.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`

Search positions that may render incorrect results are highlighted in the header comments. If position is less than or greater than the text range for searching, an U_INDEX_OUTOFBOUNDS_ERROR will be returned.

When `USEARCH_OVERLAP` option is off, the last index of the result match is always less than `position`. When `USERARCH_OVERLAP` is on, the result match may span across `position`.

Parameters

  strsrch | search iterator data struct
  position | index position the search is to begin at
  status | for errors if it occurs

Returns
  The character index of the first match preceding `pos`, or `USEARCH_DONE` if there are no matches.

See Also
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

int32_t usearch_previous | ( | UStringSearch * | strsrch,
|  | UErrorCode * | status
| ) |  |

Returns the index of the previous point at which the string text matches the search pattern, starting at the current position.

The iterator is adjusted so that its current index (as returned by `usearch_getOffset`) is the match position if one was found. If a match is not found, `USEARCH_DONE` will be returned and the iterator will be adjusted to the index `USEARCH_DONE`

Parameters

  strsrch | search iterator data struct
  status | for errors if it occurs

Returns
  The index of the previous match before the current position, or `USEARCH_DONE` if there are no more matches.

See Also
  usearch_last
  usearch_getOffset
  USEARCH_DONE

Stable:
  ICU 2.4

void usearch_reset | ( | UStringSearch * | strsrch | ) |

Reset the iteration.

Search will begin at the start of the text string if a forward iteration is initiated before a backwards iteration. Otherwise if a backwards iteration is initiated before a forwards iteration, the search will begin at the end of the text string.

Parameters

  strsrch | search iterator data struct

See Also
  usearch_first

Stable:
  ICU 2.4

UBool usearch_search | ( | UStringSearch * | strsrch,
|  | int32_t | startIdx,
|  | int32_t * | matchStart,
|  | int32_t * | matchLimit,
|  | UErrorCode * | status
| ) |  |

Simple forward search for the pattern, starting at a specified index, and using using a default set search options.

This is an experimental function, and is not an official part of the ICU API.

The collator options, such as UCOL_STRENGTH and UCOL_NORMALIZTION, are honored.

The UStringSearch options USEARCH_CANONICAL_MATCH, USEARCH_OVERLAP and any Break Iterator are ignored.

Matches obey the following constraints:

    Characters at the start or end positions of a match that are ignorable
    for collation are not included as part of the match, unless they
    are part of a combining sequence, as described below.

    A match will not include a partial combining sequence.  Combining
    character sequences  are considered to be  inseperable units,
    and either match the pattern completely, or are considered to not match
    at all.  Thus, for example, an A followed a combining accent mark will
    not be found when searching for a plain (unaccented) A.   (unless
    the collation strength has been set to ignore all accents).

    When beginning a search, the initial starting position, startIdx,
    is assumed to be an acceptable match boundary with respect to
    combining characters.  A combining sequence that spans across the
    starting point will not supress a match beginning at startIdx.

    Characters that expand to multiple collation elements
    (German sharp-S becoming 'ss', or the composed forms of accented
    characters, for example) also must match completely.
    Searching for a single 's' in a string containing only a sharp-s will
    find no match.

Parameters

  strsrch | the UStringSearch struct, which references both the text to be searched and the pattern being sought.
  startIdx | The index into the text to begin the search.
  matchStart | An out parameter, the starting index of the matched text. This parameter may be NULL. A value of -1 will be returned if no match was found.
  matchLimit | Out parameter, the index of the first position following the matched text. The matchLimit will be at a suitable position for beginning a subsequent search in the input text. This parameter may be NULL. A value of -1 will be returned if no match was found.
  status | Report any errors. Note that no match found is not an error.

Returns
  TRUE if a match was found, FALSE otherwise.

Internal:
  Do not use. This API is for internal use only.

UBool usearch_searchBackwards | ( | UStringSearch * | strsrch,
|  | int32_t | startIdx,
|  | int32_t * | matchStart,
|  | int32_t * | matchLimit,
|  | UErrorCode * | status
| ) |  |

Simple backwards search for the pattern, starting at a specified index, and using using a default set search options.

This is an experimental function, and is not an official part of the ICU API.

The collator options, such as UCOL_STRENGTH and UCOL_NORMALIZTION, are honored.

The UStringSearch options USEARCH_CANONICAL_MATCH, USEARCH_OVERLAP and any Break Iterator are ignored.

Matches obey the following constraints:

    Characters at the start or end positions of a match that are ignorable
    for collation are not included as part of the match, unless they
    are part of a combining sequence, as described below.

    A match will not include a partial combining sequence.  Combining
    character sequences  are considered to be  inseperable units,
    and either match the pattern completely, or are considered to not match
    at all.  Thus, for example, an A followed a combining accent mark will
    not be found when searching for a plain (unaccented) A.   (unless
    the collation strength has been set to ignore all accents).

    When beginning a search, the initial starting position, startIdx,
    is assumed to be an acceptable match boundary with respect to
    combining characters.  A combining sequence that spans across the
    starting point will not supress a match beginning at startIdx.

    Characters that expand to multiple collation elements
    (German sharp-S becoming 'ss', or the composed forms of accented
    characters, for example) also must match completely.
    Searching for a single 's' in a string containing only a sharp-s will
    find no match.

Parameters

  strsrch | the UStringSearch struct, which references both the text to be searched and the pattern being sought.
  startIdx | The index into the text to begin the search.
  matchStart | An out parameter, the starting index of the matched text. This parameter may be NULL. A value of -1 will be returned if no match was found.
  matchLimit | Out parameter, the index of the first position following the matched text. The matchLimit will be at a suitable position for beginning a subsequent search in the input text. This parameter may be NULL. A value of -1 will be returned if no match was found.
  status | Report any errors. Note that no match found is not an error.

Returns
  TRUE if a match was found, FALSE otherwise.

Internal:
  Do not use. This API is for internal use only.

void usearch_setAttribute | ( | UStringSearch * | strsrch,
|  | USearchAttribute | attribute,
|  | USearchAttributeValue | value,
|  | UErrorCode * | status
| ) |  |

Sets the text searching attributes located in the enum USearchAttribute with values from the enum USearchAttributeValue.

`USEARCH_DEFAULT` can be used for all attributes for resetting.

Parameters

  strsrch | search iterator data struct
  attribute | text attribute to be set
  value | text attribute value
  status | for errors if it occurs

See Also
  usearch_getAttribute

Stable:
  ICU 2.4

void usearch_setBreakIterator | ( | UStringSearch * | strsrch,
|  | UBreakIterator * | breakiter,
|  | UErrorCode * | status
| ) |  |

Set the BreakIterator that will be used to restrict the points at which matches are detected.

Parameters

  strsrch | search iterator data struct
  breakiter | A BreakIterator that will be used to restrict the points at which matches are detected. If a match is found, but the match's start or end index is not a boundary as determined by the `BreakIterator`, the match will be rejected and another will be searched for. If this parameter is `NULL`, no break detection is attempted.
  status | for errors if it occurs

See Also
  usearch_getBreakIterator

Stable:
  ICU 2.4

void usearch_setCollator | ( | UStringSearch * | strsrch,
|  | const UCollator * | collator,
|  | UErrorCode * | status
| ) |  |

Sets the collator used for the language rules.

User retains the ownership of this collator, thus the responsibility of deletion lies with the user. This method causes internal data such as Boyer-Moore shift tables to be recalculated, but the iterator's position is unchanged.

Parameters

  strsrch | search iterator data struct
  collator | to be used
  status | for errors if it occurs

Stable:
  ICU 2.4

void usearch_setOffset | ( | UStringSearch * | strsrch,
|  | int32_t | position,
|  | UErrorCode * | status
| ) |  |

Sets the current position in the text string which the next search will start from.

Clears previous states. This method takes the argument index and sets the position in the text string accordingly without checking if the index is pointing to a valid starting point to begin searching. Search positions that may render incorrect results are highlighted in the header comments

Parameters

  strsrch | search iterator data struct
  position | position to start next search from. If position is less than or greater than the text range for searching, an U_INDEX_OUTOFBOUNDS_ERROR will be returned
  status | error status if any.

Stable:
  ICU 2.4

void usearch_setPattern | ( | UStringSearch * | strsrch,
|  | const UChar * | pattern,
|  | int32_t | patternlength,
|  | UErrorCode * | status
| ) |  |

Sets the pattern used for matching.

Internal data like the Boyer Moore table will be recalculated, but the iterator's position is unchanged.

Parameters

  strsrch | search iterator data struct
  pattern | string
  patternlength | pattern length, -1 for null-terminated string
  status | for errors if it occurs. If text is NULL, or textlength is 0 then an U_ILLEGAL_ARGUMENT_ERROR is returned with no change done to strsrch.

Stable:
  ICU 2.4

void usearch_setText | ( | UStringSearch * | strsrch,
|  | const UChar * | text,
|  | int32_t | textlength,
|  | UErrorCode * | status
| ) |  |

Set the string text to be searched.

Text iteration will hence begin at the start of the text string. This method is useful if you want to re-use an iterator to search for the same pattern within a different body of text.

Parameters

  strsrch | search iterator data struct
  text | new string to look for match
  textlength | length of the new string, -1 for null-termination
  status | for errors if it occurs. If text is NULL, or textlength is 0 then an U_ILLEGAL_ARGUMENT_ERROR is returned with no change done to strsrch.

See Also
  usearch_getText

Stable:
  ICU 2.4